Libosmium: osmium::index::IdSet< T > Class Template Reference

Libosmium Fast and flexible C++ library for working with OpenStreetMap data

Loading...
Searching...
No Matches
Public Member Functions | List of all members
osmium::index::IdSet< T > Class Template Referenceabstract

`#include <id_set.hpp>`

Inheritance diagram for osmium::index::IdSet< T >:
[legend]

## Public Member Functions
| IdSet ()=default
| IdSet (const IdSet &)=default
IdSet & | operator= (const IdSet &)=default
| IdSet (IdSet &&) noexcept=default
IdSet & | operator= (IdSet &&) noexcept=default
virtual | ~IdSet () noexcept=default
virtual void | set (T id)=0
virtual bool | get (T id) const noexcept=0
virtual bool | empty () const =0
virtual void | clear ()=0
virtual std::size_t | used_memory () const noexcept=0

## Detailed Description

template<typename T>
class osmium::index::IdSet< T >

Virtual parent class for IdSets. Use one of the implementations provided.

## Constructor & Destructor Documentation

## ◆ IdSet() [1/3]

template<typename T>

osmium::index::IdSet< T >::IdSet | ( |  | ) |
| default

## ◆ IdSet() [2/3]

template<typename T>

osmium::index::IdSet< T >::IdSet | ( | const IdSet< T > & |  | ) |
| default

## ◆ IdSet() [3/3]

template<typename T>

osmium::index::IdSet< T >::IdSet | ( | IdSet< T > && |  | ) |
| defaultnoexcept

## ◆ ~IdSet()

template<typename T>

virtual osmium::index::IdSet< T >::~IdSet | ( |  | ) |
| virtualdefaultnoexcept

## Member Function Documentation

## ◆ clear()

template<typename T>

virtual void osmium::index::IdSet< T >::clear | ( |  | ) |
| pure virtual

Clear the set.

Implemented in osmium::index::IdSetDense< T, chunk_bits >, and osmium::index::IdSetSmall< T >.

## ◆ empty()

template<typename T>

virtual bool osmium::index::IdSet< T >::empty | ( |  | ) | const
| pure virtual

Is the set empty?

Implemented in osmium::index::IdSetDense< T, chunk_bits >, and osmium::index::IdSetSmall< T >.

## ◆ get()

template<typename T>

virtual bool osmium::index::IdSet< T >::get | ( | T | id | ) | const
| pure virtualnoexcept

Is the Id in the set?

Implemented in osmium::index::IdSetDense< T, chunk_bits >, and osmium::index::IdSetSmall< T >.

## ◆ operator=() [1/2]

template<typename T>

IdSet & osmium::index::IdSet< T >::operator= | ( | const IdSet< T > & |  | ) |
| default

## ◆ operator=() [2/2]

template<typename T>

IdSet & osmium::index::IdSet< T >::operator= | ( | IdSet< T > && |  | ) |
| defaultnoexcept

## ◆ set()

template<typename T>

virtual void osmium::index::IdSet< T >::set | ( | T | id | ) |
| pure virtual

Add the given Id to the set.

Implemented in osmium::index::IdSetDense< T, chunk_bits >, and osmium::index::IdSetSmall< T >.

## ◆ used_memory()

template<typename T>

virtual std::size_t osmium::index::IdSet< T >::used_memory | ( |  | ) | const
| pure virtualnoexcept

Get an estimate of the amount of memory used for the set.

Implemented in osmium::index::IdSetDense< T, chunk_bits >, and osmium::index::IdSetSmall< T >.

The documentation for this class was generated from the following file:

- include/osmium/index/id_set.hpp